/**================================================================================================
Hochschule Luzern - Technik & Architektur                                  Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                    http://hslu.ximit.ch
---------------------------------------------------------------------------------------------------
Name        : getop.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-10-07v1.0
Description : Taschenrechner polnische Notation
              naechsten Operator und /oder numerischen Operanden holen
=================================================================================================*/


#include <stdio.h>
#include <stdlib.h>		/* fuer atof() */
#include <ctype.h>		/* fuer isdigit() */
#include <string.h>		/* fuer strcmp() */
#include "calc.h"		/* Eigene Methoden einbinden */

/*getop: naechsten Operator und /oder numerischen Operanden holen */
int getop(char s[]){
    int i, c, cOld;

    while ((s[0] = c = getch()) == ' ' || c == '\t')
		; // whitespaces entfernen - tue nichts

    s[1] = '\0'; // String terminieren

    if (!isdigit(c) && c != '.') { // Befehl Sammeln
		cOld = c;
		i = 0;
		
		while (isalpha(s[++i] = c = getch())) { // solange es ein char ist
            ; // do nothing
		}
		s[i] = '\0'; // String terminieren
		if (!isalpha(c)) {
			ungetch(c);
		}
		
		if (strcmp(s, "sin") == 0) {
			return FN_SIN; // Sinus
		} else if (strcmp(s, "cos") == 0) {
			return FN_COS; // Cosinus
		} else if (strcmp(s, "tan") == 0) {
			return FN_TAN; // Tangens
		} else if (strcmp(s, "exp") == 0) {
			return FN_EXP; // Exponent
		} else if (strcmp(s, "power") == 0) {
			return FN_POWER; // Power
		} else {
			return cOld; // keine Zahl --> Befehl
		}
	}
    i = 0;
    if (isdigit(c)) { /* ganzzahligen Teil sammeln */
        while (isdigit(s[++i] = c = getch())) // solange es eine Zahl ist
            ;
	}
    if (c == '.') { /* Dezimalstellen */
        while (isdigit(s[++i] = c = getch())) // solange es eine Zahl ist
            ;
	}
    s[i] = '\0'; // String terminieren
    if (c != EOF) { // solange nicht am Ende von der Zeile
        ungetch(c); // Zeichen zurck auf Stack
	}

    return NUMBER; // default return wert 0
}
