/**================================================================================================
Hochschule Luzern - Technik & Architektur                                  Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                    http://hslu.ximit.ch
---------------------------------------------------------------------------------------------------
Name        : main.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-10-07v1.0
Description : Ampel
              Schreiben Sie eine kleine Ampel-Simulation, welche der Reihe nach die Zustnde
			  RED  GREEN  GREEN_BLINKING  YELLOW  RED  etc. annimmt.
=================================================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <windows.h> /* Sleep() */
#include "ampel.h"

/**
 * The main procedure to run the application.
 * @param argc Number of command line arguments
 * @param argv The forwarded command line arguments
 * @return Application return (error) code
 */
int main(int argc, char** argv)
{
	int i;

	for(i=0; i<3; i++) // dreimal wiederholen
	{
		// Rot
		printState();
		printf("  State: %i\n", getState());
		Sleep(5000); // 6sec delay
		nextState();

		// Gruen
		printState();
		printf("  State: %i\n", getState());
		Sleep(3000); // 4sec delay
		nextState();

		// Gruen-Blinkend
		printState();
		printf("  State: %i\n", getState());
		Sleep(1000); // 1sec delay
		nextState();

		// Gelb
		printState();
		printf("  State: %i\n", getState());
		Sleep(1000); // 1sec delay
		nextState();

		//printf("\n-----------------------\n\n");
	} // dreimal wiederholen

	
	fflush(stdin); //flushes the input stream and gets rid of '\n'
	printf("\n\nPress [Enter] to exit...");
	getchar();
	return(EXIT_SUCCESS);
}
