/**================================================================================================
Hochschule Luzern - Technik & Architektur                                  Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                    http://hslu.ximit.ch
---------------------------------------------------------------------------------------------------
Name        : queue.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-10-07v1.0
Description : Message Queue
=================================================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include "queue.h"


MessageQueue* initialize() {
	//create a new Queue
	MessageQueue* aQueue = (MessageQueue*) malloc(sizeof(MessageQueue));	/* allocate Memory */
	aQueue->size=0;															/* init Size 0 */
	return aQueue;
}

int enqueue(MessageQueue *aQueue, int aValue) {
	//create a new Node
	Node* newNode = (Node*) malloc(sizeof(Node));	/* allocate Memory */
	newNode->data = aValue;							/* set the data of the Node */
	newNode->next = NULL;							/* newNode is the last Element (no next) */

	if (aQueue->size == 0) {						/* check if the Queue is empty */
		aQueue->head=newNode;						/* if the Queue is empty set the HEAD */
	} else {
		aQueue->rear->next = newNode;				/* if the Queue is not empty set the next node */
	}
  
	aQueue->rear=newNode;							/* set the new Node as the new REAR */
	aQueue->size++;									/* increase the size of the Queue */
	return aValue;
}

int dequeue(MessageQueue *aQueue) {
	int tmpData;
	Node* removeNode;

	while (aQueue->size == 0) {			/* wait if the queue is empty --> DEAD LOCK !!! */
		printf("Queue is empty...\n");
		Sleep(2000);
	}

	tmpData = aQueue->head->data;		/* get Data */
	removeNode = aQueue->head;			/* temp var. used for free() memory */
	aQueue->head = aQueue->head->next;	/* remove Node from Queue */

	free(removeNode);  					/* release memory */
	aQueue->size--;						/* decrease Queue size */ 
	return tmpData;
}
